<template lang="pug">
  .mobile-menu(:class="{ portrait: isPortrait }")
    template(v-if="isPortrait")
      .columns
        .left
          .scroll-container
            stage-sizes-panel(
              @select="selectSize"
              :isMobile="true"
            )
        .right
          header
            auth(:isMobile="true")
            .shadow
          .export.button(@click="toggleLayout()")
            .icon(v-html="$icons.rotate")
            div Rotate screen
      .close-button(
        v-html="$icons.close"
        @click="$emit('close')"
      )
    template(v-else)
      header
        auth(:isMobile="true")
        .shadow
        .close-button(
          v-html="$icons.close"
          @click="$emit('close')"
        )
      .scroll-container
        stage-sizes-panel(@select="selectSize")
      .export.button(@click="toggleLayout()")
        .icon(v-html="$icons.rotate")
        div Rotate screen

    transition(name="scale-fade")
      .backdrop(v-if="showStageCustomeSizes")
        .stage-custom-sizes
          .block
            .form
              input(
                v-model="stageWidth"
                :class="{ error: wrongWidth }"
              )
              span x
              input(
                v-model="stageHeight"
                :class="{ error: wrongHeight }"
              )
            .button.black(@click="setStageSize()") SET
</template>

<script>
import { mapState } from 'vuex'
import config from '../../config'
import storeService from '../../services/store'
import stageService from '../../services/stage'
import ResizeStageCommand from '../../history/commands/resizeStage'

export default {
  name: 'MobileMainMenu',
  data () {
    return {
      showStageCustomeSizes: false,
      wrongWidth: false,
      wrongHeight: false,
      stageWidth: null,
      stageHeight: null,
      maxWidth: config.stage.sideMaxWidth,
      maxHeight: config.stage.sideMaxWidth,
      minWidth: config.stage.minWidth,
      minHeight: config.stage.minHeight
    }
  },
  computed: {
    ...mapState({
      isPortrait: state => state.editor.isPortrait,
      stageRealWidth: state => state.editor.stage.realWidth,
      stageRealHeight: state => state.editor.stage.realHeight
    })
  },
  watch: {
    stageRealWidth () {
      this.handleStageSizeChange()
    },
    stageRealHeight () {
      this.handleStageSizeChange()
    },
    stageWidth () {
      this.checkSizes()
    },
    stageHeight () {
      this.checkSizes()
    }
  },
  mounted () {
    this.stageWidth = this.stageRealWidth
    this.stageHeight = this.stageRealHeight
  },
  methods: {
    selectSize (size) {
      this.$emit('select-size', size)
      if (size === null) {
        this.showStageCustomeSizes = true
      }
    },
    toggleLayout () {
      stageService.rotate()
      this.$emit('close')
    },
    setStageSize () {
      if (this.checkSizes()) {
        this.$emit('close')
        storeService.get('commandManager').execute(new ResizeStageCommand(this.stageWidth, this.stageHeight))
      }
    },
    handleStageSizeChange () {
      this.stageWidth = this.stageRealWidth
      this.stageHeight = this.stageRealHeight
    },
    checkSizes () {
      const isStageWidthValid =
          /\d+/.test(this.stageWidth) &&
          this.stageWidth >= this.minWidth &&
          this.stageWidth <= this.maxWidth
      const isStageHeightValid =
          /\d+/.test(this.stageHeight) &&
          this.stageHeight >= this.minHeight &&
          this.stageHeight <= this.maxHeight

      this.wrongWidth = !isStageWidthValid
      this.wrongHeight = !isStageHeightValid

      return isStageWidthValid && isStageHeightValid
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/css/effects';

.mobile-menu {
  width: 100%;
  height: 100vh;
  height: calc(var(--vh, 1vh) * 100);
  display: flex;
  flex-direction: column;
  position: absolute;
  z-index: 20;
  top: 0;
  left: 0;
  background-color: #242424;
  padding: 12px 16px 16px 16px;

  .columns {
    display: flex;
    flex-direction: row;

    .left, .right {
      width: 50%;
    }

    .right {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      padding-left: 8px;

      .button {
        width: 100%;
        margin-top: 36px;
      }
    }
  }

  header {
    height: 32px;
    min-height: 32px;
    position: relative;
    display: flex;
    align-items: center;
    flex-direction: row;

    .shadow {
      width: 64px;
      height: 100%;
      position: absolute;
      right: -16px;
      z-index: 10;
      background: linear-gradient(to left, #242424 80%, transparent 130%);
    }

    .close-button {
      top: 0;
      right: 0;
      z-index: 20;
    }
  }

  .stage-sizes-panel {
    margin-top: 24px;

    /deep/ .active, /deep/ .row:hover {
      border-radius: 6px;
    }
  }

  .scroll-container {
    height: calc(100vh - 114px);
    overflow: auto;
  }

  .export {
    position: relative;
    height: 54px;

    &::before {
      content: '';
      width: 100%;
      height: 20px;
      position: absolute;
      top: -20px;
      background: linear-gradient(to top, #242424 32%, transparent 100%);
    }

    .icon {
      width: 21px;
      height: 20px;
      fill: rgba(0, 0, 0, 0.4);
      margin: 0 8px 4px 0;
    }
  }

  .stage-custom-sizes {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    background-color: #fff;
    border-radius: 10px;
    padding: 24px 16px 16px 16px;

    .form {
      width: 152px;
      display: flex;
      flex-direction: row;
      align-items: center;
      justify-content: space-between;
      margin: 0 auto;
      color: rgba(0, 0, 0, 0.5);

      input {
        width: 64px;
        height: 40px;
        border: none;
        border-radius: 10px;
        background-color: rgba(0, 0, 0, 0.1);
        text-align: center;

        &.error {
          background-color: #d00606;
          color: #fff;
        }
      }
    }

    .button {
      width: 256px;
      height: 52px;
      margin-top: 24px;

      &:hover {
        background-color: #313131;
      }
    }
  }

  .block {
    transition: all 0.1s;
  }

  &.portrait {
    header {
      width: 100%;
      justify-content: center;
      margin-right: -16px;

      .shadow {
        width: 80px;
        right: -8px;
        background: linear-gradient(to left, #242424 10%, transparent 90%);
      }
    }

    .scroll-container {
      height: calc(100vh - 12px);
    }

    .stage-sizes-panel {
      margin-top: 0;
    }
  }
}
</style>
